diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/network/utils/radiotap-header.cc ns-3.44/src/network/utils/radiotap-header.cc
--- ns-3.43/src/network/utils/radiotap-header.cc	2024-10-09 16:41:10.072656600 -0700
+++ ns-3.44/src/network/utils/radiotap-header.cc	2025-03-09 16:55:49.679372300 -0700
@@ -11,6 +11,7 @@
 
 #include "ns3/log.h"
 
+#include <bit>
 #include <cmath>
 #include <iomanip>
 
@@ -22,40 +23,6 @@
 NS_OBJECT_ENSURE_REGISTERED(RadiotapHeader);
 
 RadiotapHeader::RadiotapHeader()
-    : m_length(8),
-      m_present(0),
-      m_tsft(0),
-      m_flags(FRAME_FLAG_NONE),
-      m_rate(0),
-      m_channelFreq(0),
-      m_channelFlags(CHANNEL_FLAG_NONE),
-      m_antennaSignal(0),
-      m_antennaNoise(0),
-      m_ampduStatusRef(0),
-      m_ampduStatusFlags(0),
-      m_ampduStatusCRC(0),
-      m_vhtPad(0),
-      m_vhtKnown(0),
-      m_vhtFlags(0),
-      m_vhtBandwidth(0),
-      m_vhtCoding(0),
-      m_vhtGroupId(0),
-      m_vhtPartialAid(0),
-      m_hePad(0),
-      m_heData1(0),
-      m_heData2(0),
-      m_heData3(0),
-      m_heData4(0),
-      m_heData5(0),
-      m_heData6(0),
-      m_heMuPad(0),
-      m_heMuFlags1(0),
-      m_heMuFlags2(0),
-      m_heMuOtherUserPad(0),
-      m_heMuPerUser1(0),
-      m_heMuPerUser2(0),
-      m_heMuPerUserPosition(0),
-      m_heMuPerUserKnown(0)
 {
     NS_LOG_FUNCTION(this);
 }
@@ -93,6 +60,10 @@
     start.WriteU8(0);          // pad field
     start.WriteU16(m_length);  // entire length of radiotap data + header
     start.WriteU32(m_present); // bits describing which fields follow header
+    if (m_presentExt)
+    {
+        start.WriteU32(*m_presentExt); // extended bitmasks
+    }
 
     //
     // Time Synchronization Function Timer (when the first bit of the MPDU
@@ -128,9 +99,7 @@
     //
     if (m_present & RADIOTAP_CHANNEL) // bit 3
     {
-        start.WriteU8(0, m_channelPad);
-        start.WriteU16(m_channelFreq);
-        start.WriteU16(m_channelFlags);
+        SerializeChannel(start);
     }
 
     //
@@ -245,9 +214,7 @@
     //
     if (m_present & RADIOTAP_MCS) // bit 19
     {
-        start.WriteU8(m_mcsKnown);
-        start.WriteU8(m_mcsFlags);
-        start.WriteU8(m_mcsRate);
+        SerializeMcs(start);
     }
 
     //
@@ -256,11 +223,7 @@
     //
     if (m_present & RADIOTAP_AMPDU_STATUS) // bit 20
     {
-        start.WriteU8(0, m_ampduStatusPad);
-        start.WriteU32(m_ampduStatusRef);
-        start.WriteU16(m_ampduStatusFlags);
-        start.WriteU8(m_ampduStatusCRC);
-        start.WriteU8(0);
+        SerializeAmpduStatus(start);
     }
 
     //
@@ -269,17 +232,7 @@
     //
     if (m_present & RADIOTAP_VHT) // bit 21
     {
-        start.WriteU8(0, m_vhtPad);
-        start.WriteU16(m_vhtKnown);
-        start.WriteU8(m_vhtFlags);
-        start.WriteU8(m_vhtBandwidth);
-        for (uint8_t i = 0; i < 4; i++)
-        {
-            start.WriteU8(m_vhtMcsNss[i]);
-        }
-        start.WriteU8(m_vhtCoding);
-        start.WriteU8(m_vhtGroupId);
-        start.WriteU16(m_vhtPartialAid);
+        SerializeVht(start);
     }
 
     //
@@ -288,13 +241,7 @@
     //
     if (m_present & RADIOTAP_HE) // bit 23
     {
-        start.WriteU8(0, m_hePad);
-        start.WriteU16(m_heData1);
-        start.WriteU16(m_heData2);
-        start.WriteU16(m_heData3);
-        start.WriteU16(m_heData4);
-        start.WriteU16(m_heData5);
-        start.WriteU16(m_heData6);
+        SerializeHe(start);
     }
 
     //
@@ -303,17 +250,7 @@
     //
     if (m_present & RADIOTAP_HE_MU) // bit 24
     {
-        start.WriteU8(0, m_heMuPad);
-        start.WriteU16(m_heMuFlags1);
-        start.WriteU16(m_heMuFlags2);
-        start.WriteU8(0);
-        start.WriteU8(0);
-        start.WriteU8(0);
-        start.WriteU8(0);
-        start.WriteU8(0);
-        start.WriteU8(0);
-        start.WriteU8(0);
-        start.WriteU8(0);
+        SerializeHeMu(start);
     }
 
     //
@@ -322,11 +259,25 @@
     //
     if (m_present & RADIOTAP_HE_MU_OTHER_USER) // bit 25
     {
-        start.WriteU8(0, m_heMuOtherUserPad);
-        start.WriteU16(m_heMuPerUser1);
-        start.WriteU16(m_heMuPerUser2);
-        start.WriteU8(m_heMuPerUserPosition);
-        start.WriteU8(m_heMuPerUserKnown);
+        SerializeHeMuOtherUser(start);
+    }
+
+    //
+    // U-SIG field.
+    // Reference: https://www.radiotap.org/fields/U-SIG.html
+    //
+    if (m_presentExt && (*m_presentExt & RADIOTAP_USIG)) // bit 33
+    {
+        SerializeUsig(start);
+    }
+
+    //
+    // EHT field.
+    // Reference: https://www.radiotap.org/fields/EHT.html
+    //
+    if (m_presentExt && (*m_presentExt & RADIOTAP_EHT_SIG)) // bit 34
+    {
+        SerializeEht(start);
     }
 }
 
@@ -341,9 +292,15 @@
 
     m_length = start.ReadU16();  // entire length of radiotap data + header
     m_present = start.ReadU32(); // bits describing which fields follow header
-
     uint32_t bytesRead = 8;
 
+    if (m_present & RADIOTAP_EXT)
+    {
+        // If bit 31 of the it_present field is set, an extended it_present bitmask is present.
+        m_presentExt = start.ReadU32();
+        bytesRead += 4;
+    }
+
     //
     // Time Synchronization Function Timer (when the first bit of the MPDU arrived at the MAC)
     // Reference: https://www.radiotap.org/fields/TSFT.html
@@ -380,11 +337,7 @@
     //
     if (m_present & RADIOTAP_CHANNEL) // bit 3
     {
-        m_channelPad = ((2 - bytesRead % 2) % 2);
-        start.Next(m_channelPad);
-        m_channelFreq = start.ReadU16();
-        m_channelFlags = start.ReadU16();
-        bytesRead += (4 + m_channelPad);
+        bytesRead += DeserializeChannel(start, bytesRead);
     }
 
     //
@@ -519,25 +472,16 @@
     //
     if (m_present & RADIOTAP_MCS) // bit 19
     {
-        m_mcsKnown = start.ReadU8();
-        m_mcsFlags = start.ReadU8();
-        m_mcsRate = start.ReadU8();
-        bytesRead += 3;
+        bytesRead += DeserializeMcs(start, bytesRead);
     }
 
     //
     // A-MPDU Status, information about the received or transmitted A-MPDU.
     // Reference: https://www.radiotap.org/fields/A-MPDU%20status.html
     //
-    if (m_present & RADIOTAP_AMPDU_STATUS) // bit 20
+    if (m_present & RADIOTAP_AMPDU_STATUS)
     {
-        m_ampduStatusPad = ((4 - bytesRead % 4) % 4);
-        start.Next(m_ampduStatusPad);
-        m_ampduStatusRef = start.ReadU32();
-        m_ampduStatusFlags = start.ReadU16();
-        m_ampduStatusCRC = start.ReadU8();
-        start.ReadU8();
-        bytesRead += (8 + m_ampduStatusPad);
+        bytesRead += DeserializeAmpduStatus(start, bytesRead);
     }
 
     //
@@ -546,19 +490,7 @@
     //
     if (m_present & RADIOTAP_VHT) // bit 21
     {
-        m_vhtPad = ((2 - bytesRead % 2) % 2);
-        start.Next(m_vhtPad);
-        m_vhtKnown = start.ReadU16();
-        m_vhtFlags = start.ReadU8();
-        m_vhtBandwidth = start.ReadU8();
-        for (uint8_t i = 0; i < 4; i++)
-        {
-            m_vhtMcsNss[i] = start.ReadU8();
-        }
-        m_vhtCoding = start.ReadU8();
-        m_vhtGroupId = start.ReadU8();
-        m_vhtPartialAid = start.ReadU16();
-        bytesRead += (12 + m_vhtPad);
+        bytesRead += DeserializeVht(start, bytesRead);
     }
 
     //
@@ -567,15 +499,7 @@
     //
     if (m_present & RADIOTAP_HE) // bit 23
     {
-        m_hePad = ((2 - bytesRead % 2) % 2);
-        start.Next(m_hePad);
-        m_heData1 = start.ReadU16();
-        m_heData2 = start.ReadU16();
-        m_heData3 = start.ReadU16();
-        m_heData4 = start.ReadU16();
-        m_heData5 = start.ReadU16();
-        m_heData6 = start.ReadU16();
-        bytesRead += (12 + m_hePad);
+        bytesRead += DeserializeHe(start, bytesRead);
     }
 
     //
@@ -584,18 +508,7 @@
     //
     if (m_present & RADIOTAP_HE_MU) // bit 24
     {
-        m_heMuPad = ((2 - bytesRead % 2) % 2);
-        m_heMuFlags1 = start.ReadU16();
-        m_heMuFlags2 = start.ReadU16();
-        start.ReadU8();
-        start.ReadU8();
-        start.ReadU8();
-        start.ReadU8();
-        start.ReadU8();
-        start.ReadU8();
-        start.ReadU8();
-        start.ReadU8();
-        bytesRead += (12 + m_heMuPad);
+        bytesRead += DeserializeHeMu(start, bytesRead);
     }
 
     //
@@ -604,12 +517,25 @@
     //
     if (m_present & RADIOTAP_HE_MU_OTHER_USER) // bit 25
     {
-        m_heMuOtherUserPad = ((2 - bytesRead % 2) % 2);
-        m_heMuPerUser1 = start.ReadU16();
-        m_heMuPerUser2 = start.ReadU16();
-        m_heMuPerUserPosition = start.ReadU8();
-        m_heMuPerUserKnown = start.ReadU8();
-        bytesRead += (6 + m_heMuOtherUserPad);
+        bytesRead += DeserializeHeMuOtherUser(start, bytesRead);
+    }
+
+    //
+    // U-SIG field.
+    // Reference: https://www.radiotap.org/fields/U-SIG.html
+    //
+    if (m_presentExt && (*m_presentExt & RADIOTAP_USIG)) // bit 33
+    {
+        bytesRead += DeserializeUsig(start, bytesRead);
+    }
+
+    //
+    // EHT field.
+    // Reference: https://www.radiotap.org/fields/EHT.html
+    //
+    if (m_presentExt && (*m_presentExt & RADIOTAP_EHT_SIG)) // bit 34
+    {
+        bytesRead += DeserializeEht(start, bytesRead);
     }
 
     NS_ASSERT_MSG(m_length == bytesRead,
@@ -621,34 +547,55 @@
 RadiotapHeader::Print(std::ostream& os) const
 {
     NS_LOG_FUNCTION(this << &os);
-    os << " tsft=" << m_tsft << " flags=" << std::hex << m_flags << std::dec << " rate=" << +m_rate
-       << " freq=" << m_channelFreq << " chflags=" << std::hex << +m_channelFlags << std::dec
-       << " signal=" << +m_antennaSignal << " noise=" << +m_antennaNoise
-       << " mcsKnown=" << m_mcsKnown << " mcsFlags=" << m_mcsFlags << " mcsRate=" << m_mcsRate
-       << " ampduStatusFlags=" << +m_ampduStatusFlags << " vhtKnown=" << m_vhtKnown
-       << " vhtFlags=" << m_vhtFlags << " vhtBandwidth=" << m_vhtBandwidth
-       << " vhtMcsNss for user 1=" << m_vhtMcsNss[0] << " vhtMcsNss for user 2=" << m_vhtMcsNss[1]
-       << " vhtMcsNss for user 3=" << m_vhtMcsNss[2] << " vhtMcsNss for user 4=" << m_vhtMcsNss[3]
-       << " vhtCoding=" << m_vhtCoding << " vhtGroupId=" << m_vhtGroupId
-       << " vhtPartialAid=" << m_vhtPartialAid << " heData1=" << m_heData1
-       << " heData2=" << m_heData2 << " heData3=" << m_heData3 << " heData4=" << m_heData4
-       << " heData5=" << m_heData5 << " heData6=" << m_heData6 << " heMuFlags1=" << m_heMuFlags1
-       << " heMuFlags2=" << m_heMuFlags2 << " heMuPerUser1=" << m_heMuPerUser1
-       << " heMuPerUser2=" << m_heMuPerUser2 << " heMuPerUserPosition=" << +m_heMuPerUserPosition
-       << " heMuPerUserKnown=" << +m_heMuPerUserKnown;
+    os << " tsft=" << m_tsft << " flags=" << std::hex << m_flags << std::dec << " rate=" << +m_rate;
+    if (m_present & RADIOTAP_CHANNEL)
+    {
+        PrintChannel(os);
+    }
+    os << std::dec << " signal=" << +m_antennaSignal << " noise=" << +m_antennaNoise;
+    if (m_present & RADIOTAP_MCS)
+    {
+        PrintMcs(os);
+    }
+    if (m_present & RADIOTAP_AMPDU_STATUS)
+    {
+        PrintAmpduStatus(os);
+    }
+    if (m_present & RADIOTAP_VHT)
+    {
+        PrintVht(os);
+    }
+    if (m_present & RADIOTAP_HE)
+    {
+        PrintHe(os);
+    }
+    if (m_present & RADIOTAP_HE_MU)
+    {
+        PrintHeMu(os);
+    }
+    if (m_present & RADIOTAP_HE_MU_OTHER_USER)
+    {
+        PrintHeMuOtherUser(os);
+    }
+    if (m_presentExt && (*m_presentExt & RADIOTAP_USIG))
+    {
+        PrintUsig(os);
+    }
+    if (m_presentExt && (*m_presentExt & RADIOTAP_EHT_SIG))
+    {
+        PrintEht(os);
+    }
 }
 
 void
 RadiotapHeader::SetTsft(uint64_t value)
 {
     NS_LOG_FUNCTION(this << value);
-    m_tsft = value;
 
-    if (!(m_present & RADIOTAP_TSFT))
-    {
-        m_present |= RADIOTAP_TSFT;
-        m_length += 8;
-    }
+    NS_ASSERT_MSG(!(m_present & RADIOTAP_TSFT), "TSFT radiotap field already present");
+    m_present |= RADIOTAP_TSFT;
+    m_length += 8;
+    m_tsft = value;
 
     NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present
                       << std::dec);
@@ -658,13 +605,11 @@
 RadiotapHeader::SetFrameFlags(uint8_t flags)
 {
     NS_LOG_FUNCTION(this << +flags);
-    m_flags = flags;
 
-    if (!(m_present & RADIOTAP_FLAGS))
-    {
-        m_present |= RADIOTAP_FLAGS;
-        m_length += 1;
-    }
+    NS_ASSERT_MSG(!(m_present & RADIOTAP_FLAGS), "Flags radiotap field already present");
+    m_present |= RADIOTAP_FLAGS;
+    m_length += 1;
+    m_flags = flags;
 
     NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present
                       << std::dec);
@@ -674,46 +619,66 @@
 RadiotapHeader::SetRate(uint8_t rate)
 {
     NS_LOG_FUNCTION(this << +rate);
-    m_rate = rate;
 
-    if (!(m_present & RADIOTAP_RATE))
-    {
-        m_present |= RADIOTAP_RATE;
-        m_length += 1;
-    }
+    NS_ASSERT_MSG(!(m_present & RADIOTAP_RATE), "Rate radiotap field already present");
+    m_present |= RADIOTAP_RATE;
+    m_length += 1;
+    m_rate = rate;
 
     NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present
                       << std::dec);
 }
 
 void
-RadiotapHeader::SetChannelFrequencyAndFlags(uint16_t frequency, uint16_t flags)
+RadiotapHeader::SetChannelFields(const ChannelFields& channelFields)
 {
-    NS_LOG_FUNCTION(this << frequency << flags);
-    m_channelFreq = frequency;
-    m_channelFlags = flags;
+    NS_LOG_FUNCTION(this << channelFields.frequency << channelFields.flags);
 
-    if (!(m_present & RADIOTAP_CHANNEL))
-    {
-        m_channelPad = ((2 - m_length % 2) % 2);
-        m_present |= RADIOTAP_CHANNEL;
-        m_length += (4 + m_channelPad);
-    }
+    NS_ASSERT_MSG(!(m_present & RADIOTAP_CHANNEL), "Channel radiotap field already present");
+    m_channelPad = ((2 - m_length % 2) % 2);
+    m_present |= RADIOTAP_CHANNEL;
+    m_length += (sizeof(ChannelFields) + m_channelPad);
+    m_channelFields = channelFields;
 
     NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present
                       << std::dec);
 }
 
 void
+RadiotapHeader::SerializeChannel(Buffer::Iterator& start) const
+{
+    start.WriteU8(0, m_channelPad);
+    start.WriteU16(m_channelFields.frequency);
+    start.WriteU16(m_channelFields.flags);
+}
+
+uint32_t
+RadiotapHeader::DeserializeChannel(Buffer::Iterator start, uint32_t bytesRead)
+{
+    m_channelPad = ((2 - bytesRead % 2) % 2);
+    start.Next(m_channelPad);
+    m_channelFields.frequency = start.ReadU16();
+    m_channelFields.flags = start.ReadU16();
+    return sizeof(ChannelFields) + m_channelPad;
+}
+
+void
+RadiotapHeader::PrintChannel(std::ostream& os) const
+{
+    os << " channel.frequency=" << m_channelFields.frequency << " channel.flags=0x" << std::hex
+       << m_channelFields.flags << std::dec;
+}
+
+void
 RadiotapHeader::SetAntennaSignalPower(double signal)
 {
     NS_LOG_FUNCTION(this << signal);
 
-    if (!(m_present & RADIOTAP_DBM_ANTSIGNAL))
-    {
-        m_present |= RADIOTAP_DBM_ANTSIGNAL;
-        m_length += 1;
-    }
+    NS_ASSERT_MSG(!(m_present & RADIOTAP_DBM_ANTSIGNAL),
+                  "Antenna signal radiotap field already present");
+    m_present |= RADIOTAP_DBM_ANTSIGNAL;
+    m_length += 1;
+
     if (signal > 127)
     {
         m_antennaSignal = 127;
@@ -736,11 +701,11 @@
 {
     NS_LOG_FUNCTION(this << noise);
 
-    if (!(m_present & RADIOTAP_DBM_ANTNOISE))
-    {
-        m_present |= RADIOTAP_DBM_ANTNOISE;
-        m_length += 1;
-    }
+    NS_ASSERT_MSG(!(m_present & RADIOTAP_DBM_ANTNOISE),
+                  "Antenna noise radiotap field already present");
+    m_present |= RADIOTAP_DBM_ANTNOISE;
+    m_length += 1;
+
     if (noise > 127.0)
     {
         m_antennaNoise = 127;
